=== debian/changelog ===
ocaml (4.13.1-4) unstable; urgency=medium

  * Avoid build path ending up in binaries (Closes: #1030785)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 12 Feb 2023 11:46:40 +0100

ocaml (4.13.1-3) unstable; urgency=medium

  * Upload to unstable
  * Adapt maintainer scripts to new binary package structure
  * Do no longer provide /usr/include/caml symlink

 -- Stéphane Glondu <glondu@debian.org>  Wed, 19 Jan 2022 11:14:42 +0100

ocaml (4.13.1-2) experimental; urgency=medium

  * Put transitional packages in section oldlibs
  * Fix building of manpages on bytecode architectures
  * Restore patch putting manpages in section 3o
  * Enable fma emulation on m68k
  * Ignore tests failure on m68k

 -- Stéphane Glondu <glondu@debian.org>  Wed, 22 Dec 2021 08:17:13 +0100

ocaml (4.13.1-1) experimental; urgency=medium

  * New upstream release
  * Make *-nox packages transitional

 -- Stéphane Glondu <glondu@debian.org>  Tue, 21 Dec 2021 16:33:05 +0100

ocaml (4.11.1-5) unstable; urgency=medium

  * Do not error on warnings in autoconf (Closes: #978875)
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Thu, 25 Nov 2021 15:45:31 +0100
